<?php
/*
 plugin contextSwitch
 System event: OnHandleRequest
*/

if($modx->context->get('key') == 'mgr') return;

if($modx->event->name=='OnHandleRequest'){
    
    $cntxt_param = $modx->getOption('context_param_alias', null, 'c');
    $request_param_id = $modx->getOption('request_param_id', null, 'id');
    $friendly_urls = $modx->getOption('friendly_urls', null, true);
    $catalog_id = $modx->getOption('catalog_id',$scriptProperties,0);
    $context_key = $modx->getOption('context_key',$scriptProperties,'catalog');
    $site_start = $modx->getOption('site_start', null, 1);
    $request_uri = $_SERVER['REQUEST_URI'];
    
    if($modx->config['friendly_urls']){
        
        if(preg_match("/^\/{$context_key}(\/|$)(.*)/",$request_uri) && is_object($modx->getObject('modContext',array('key'=>$context_key)))){
            $modx->switchContext($context_key);
            $modx->config['site_start'] = $site_start;
            $modx->setPlaceholder('context_key',$context_key);
        }
        
    }else{
        
        $requestId = !empty($_REQUEST[$request_param_id]) && is_numeric($_REQUEST[$request_param_id]) ? $_REQUEST[$request_param_id] : 0;
        if(!$requestId) return;
        $resource = $modx->getObject('modResource',$requestId);
        if($resource->get('context_key') == $context_key){
            $modx->switchContext($context_key);
            $modx->config['site_start'] = $site_start;
            $modx->setPlaceholder('context_key',$context_key);
        }
        
    }

}