<?php

/**
 * @package shopkeeper
 * @subpackage processors
 */

$orderData = '';
$contacts = '';

if (empty($scriptProperties['id'])) return $modx->error->failure('Invalid data.');
$order_id = $scriptProperties['id'];
$order = $modx->getObject('SHKorder',$order_id);
if (empty($order)) return $modx->error->failure('Invalid data 2.');

if($order->get('content')){
    
    require_once MODX_CORE_PATH."components/shopkeeper/model/shopkeeper.class.php";
    require_once MODX_CORE_PATH."components/shopkeeper/model/shk_mgr.class.php";
    //require_once MODX_CORE_PATH."components/shopkeeper/include.parsetpl.php";
    $SHKmanager = new SHKmanager($modx);
    $SHKmanager->getModConfig();
    $SHKmanager->config['tplPath'] = isset($SHKmanager->config['tpl_path']) ? $SHKmanager->config['tpl_path'] :'core/components/shopkeeper/elements/chunks/ru/';
    $SHKmanager->config['orderDataTpl'] = $SHKmanager->config['order_data_tpl'];
    $SHKmanager->config['additDataTpl'] = $SHKmanager->config['addit_data_tpl'];
    
    $purchases = unserialize($order->get('content'));
    $addit_params = unserialize($order->get('addit'));
    $contacts = $order->get('contacts');
    $date = $order->get('date');
    $allowed = $order->get('allowed');
    
    $orderData = $SHKmanager->getOrderData($purchases,$addit_params);
    
    $chunk_data = $SHKmanager->getChunk('@INLINE '.$orderData);
    $orderData = $SHKmanager->parseTpl($chunk_data,array('orderID'=>$order_id, 'date'=>$date));
    
    if($SHKmanager->is_serialized($contacts)){
        $contacts_fields = unserialize($contacts);
        $contacts_str = $SHKmanager->renderContactInfo($contacts_fields);
    }else{
        $contacts_fields = array();
        $contacts_str = $contacts;
    }
    
}

return $this->outputArray(array('orderData'=>$orderData,'contacts'=>$contacts_str));

?>