<?php
/**
 * Get a list of orders
 *
 * @package shopkeeper
 * @subpackage processors
 */

require_once MODX_CORE_PATH."components/shopkeeper/model/shopkeeper.class.php";
require_once MODX_CORE_PATH."components/shopkeeper/model/shk_mgr.class.php";
require_once MODX_CORE_PATH."components/shopkeeper/include.parsetpl.php";
$SHKmanager = new SHKmanager($modx);
$SHKmanager->getModConfig();

/* setup default properties */
$isLimit = !empty($_REQUEST['limit']);
$start = $modx->getOption('start',$_REQUEST,0);
$limit = $modx->getOption('limit',$_REQUEST,20);
$sort = $modx->getOption('sort',$_REQUEST,'id');
$dir = $modx->getOption('dir',$_REQUEST,'DESC');
$query = $modx->getOption('query',$_REQUEST,'');

/* build query */
$c = $modx->newQuery('SHKorder');
if (!empty($query)) {
    $c->where(array(
        'contacts:LIKE' => '%'.$query.'%',
    ));
    $c->orCondition(array(
        'contacts:LIKE' => '%'.$query.'%',
    ));
}
$count = $modx->getCount('SHKorder',$c);
$c->sortby($sort,$dir);
if ($isLimit) $c->limit($limit,$start);
$orders = $modx->getCollection('SHKorder', $c);

/* iterate */
$list = array();
$userIds = array();
foreach ($orders as $order) {
    $orderArray = $order->toArray();
    /*$orderArray['menu'] = array();
    $orderArray['menu'][] = array(
        'text' => $modx->lexicon('shk.order_desc'),
        'handler' => 'this.viewOrder',
    );
    $orderArray['menu'][] = '-';
    $orderArray['menu'][] = array(
        'text' => $modx->lexicon('shk.order_remove'),
        'handler' => 'this.removeOrder',
    );*/
    if(!in_array($orderArray['userid'],$userIds)){
        array_push($userIds,$orderArray['userid']);
    }
    if(isset($orderArray['contacts']) && $SHKmanager->is_serialized($orderArray['contacts'])){
        $contacts_fields = unserialize($orderArray['contacts']);
        $contacts_tpl_name = $SHKmanager->config['contact_template_small'];
        $orderArray['contacts'] = $SHKmanager->renderContactInfo($contacts_fields,$contacts_tpl_name);
    }
    $list[]= $orderArray;
}

unset($c);

//получаем список имен пользователей
$webusers = array();
if(count($userIds)>0){
    $c = $modx->newQuery('modUser');
    $c->where(array('id:IN' => $userIds));
    $c->select(array('id','username'));
    $users = $modx->getCollection('modUser',$c);
    foreach ($users as $user) {
        $userArray = $user->toArray();
        $webusers[$userArray['id']] = $userArray['username'];
    }
}

foreach($list as &$val){
    if($val['userid']!=0 && in_array($val['userid'],array_keys($webusers))){
        $index = array_search($val['userid'],array_keys($webusers));
        $val['shk_username'] = current(array_slice(array_values($webusers),$index,1));
    }else{
        $val['shk_username'] = '';
    }
}

return $this->outputArray($list,$count);