<?php
/**
 * FormIt hook for Shopkeeper 2.x
 */

$output = false;
$orderData = '';

$manager_language = $modx->config['manager_language'];
$charset = $modx->config['modx_charset'];
$rb_base_url = $modx->config['rb_base_url'];
$site_url = $modx->config['site_url'];
$dbname = $modx->config['dbname'];
$dbprefix = $modx->config['table_prefix'];
$emailsender = $modx->config['emailsender'];

define('SHOPKEEPER_PATH', MODX_CORE_PATH."components/shopkeeper/");
define('SHOPKEEPER_URL', MODX_BASE_URL."core/components/shopkeeper/");
define('SHOPKEEPER_ASSETS_PATH', MODX_BASE_PATH."assets/components/shopkeeper/");
define('SHOPKEEPER_ASSETS_URL', MODX_BASE_URL."assets/components/shopkeeper/");

//Определяем параметры сниппета Shopkeeper
$sys_property_set_default = $modx->getOption('shk.property_set_default',$modx->config,'default');
$propertySetName = $modx->getOption('shkPropertySetName',$_SESSION,$sys_property_set_default);
$snippet = $modx->getObject('modSnippet',array('name'=>'Shopkeeper'));
$properties = $snippet->getProperties();
if($propertySetName!='default' && $modx->getCount('modPropertySet',array('name'=>$propertySetName))>0){
    $propSet = $modx->getObject('modPropertySet',array('name'=>$propertySetName));
    $propSetProperties = $propSet->getProperties();
    if(is_array($propSetProperties)) $properties = array_merge($properties,$propSetProperties);
}

$lang = $modx->getOption('lang',$properties,'ru');
$modx->getService('lexicon','modLexicon');
$modx->lexicon->load($lang.':shopkeeper:default');

//$user = $modx->getUser();
//$userId = $user->get('id');

if(!empty($_SESSION['shk_purchases'])){
    require_once $modx->getOption('getresources.core_path',null,$modx->getOption('core_path').'components/getresources/').'include.parsetpl.php';
    require_once SHOPKEEPER_PATH."model/shopkeeper.class.php";
    $shopCart = new Shopkeeper($modx,$properties);
    
    //проверяем созданы ли таблицы, если нет, создаем
    //$tablexists = $modx->query("SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = '".$modx->getOption('dbname')."' AND table_name = '".$modx->getOption('table_prefix')."shopkeeper_config'");
    //if($tablexists->fetch(PDO::FETCH_COLUMN)==0) $shopCart->install();
    
    $modx->addPackage('shopkeeper',SHOPKEEPER_PATH.'model/');
    
    $purchases = $_SESSION['shk_purchases'];
    $addit_params = !empty($_SESSION['shk_addit_params']) ? $_SESSION['shk_addit_params'] : array();
    list($price_total,$items_total) = $shopCart->getTotal($purchases,$addit_params);
    
    //сохраняем имена товаров
    $contentData = $shopCart->getContentData($purchases);
    foreach($purchases as & $prod){
        if(isset($contentData[$prod['id']]['pagetitle'])) $prod['name'] = $contentData[$prod['id']]['pagetitle'];
        ksort($prod);
    }
    
    $orderData = $shopCart->getOrderData($purchases,$addit_params);
    
    $allFormFields = $hook->getValues();
    unset($allFormFields['orderData'],$allFormFields['submit'],$allFormFields['formid'],$allFormFields['vericode'],$allFormFields['nospam:blank']);
    $contacts = serialize($allFormFields);
    
    $userId = $modx->getLoginUserID('web') ? $modx->getLoginUserID('web') : 0;
    
    $order = $modx->newObject('SHKorder');
    $order->fromArray(array(
      'contacts' => $contacts,
      'content' => serialize($purchases),
      'allowed' => 'all',
      'addit' => serialize($addit_params),
      'price' => $price_total,
      'currency' => $shopCart->config['currency'],
      'date' => strftime('%Y-%m-%d %H:%M:%S'),
      'sentdate' => '',
      'note' => '',
      'email' => isset($allFormFields['email']) ? $allFormFields['email'] : '',
      'phone' => isset($allFormFields['phone']) ? $allFormFields['phone'] : '',
      'delivery' => isset($allFormFields['delivery']) ? $allFormFields['delivery'] : '',
      'payment' => isset($allFormFields['payment']) ? $allFormFields['payment'] : '',
      'tracking_num' => '',
      'status' => '0',
      'userid' => $userId
    ));

    $order->save();
    
    $hook->setValues(array(
      'orderID' => $order->get('id'),
      'orderData' => $orderData,
      'date' => $order->get('date')
    ));
    
    $evtOut = $modx->invokeEvent('OnSHKsaveOrder',array('order_id' => $order->get('id')));
    
    $output = true;
    
    //сохраняем данные последнего заказа в сессию
    $shopCart->setOrderDataSession($order->toArray());
    
    //очищаем корзину
    $shopCart->emptySavedData();
  
}else{
  $orderData = "<i>".$modx->lexicon('shk.no_selected')."</i>";
  $hook->addError('error_message',$modx->lexicon('shk.order_empty'));
  $output = false;
}

return $output;